<!DOCTYPE html>
<html lang="en">

<head>
  <title>Cashonize</title>
  <link rel="icon" type="image/png" href="/images/cashonize-icon.png">
  <meta name="description" content="Cashonize: Bitcoin Cash Webwallet with CashTokens support for mainnet & chipnet.">
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="stylesheet" href="https://unpkg.com/chota@0.8.0/dist/chota.min.css">
  <link rel="stylesheet" href="style.css">
  <link rel="stylesheet" href="cashconnect.css">
  <link rel="stylesheet" href="walletconnect.css">
  <link rel="stylesheet" href="switchery/switchery.css" />
  <script src="switchery/switchery.js"></script>
  <script defer src="https://cdn.mainnet.cash/mainnet-2.3.0.js"></script>
  <script src="https://cdn.mainnet.cash/indexeddb-storage/indexeddb-storage-2.3.0.js"></script>
  <script>window.exports = {}</script>
  <script defer src="https://unpkg.com/@download/blockies@1.0.3/dist/blockies.min.js"></script>
  <script src="https://unpkg.com/@bitjson/qr-code@1.0.2/dist/qr-code.js"></script>
  <script src="https://unpkg.com/html5-qrcode" type="text/javascript"></script>
  <script defer data-domain="cashonize.com" src="https://plausible.io/js/script.js"></script>
</head>

<body>
  <div id="banner">
    The official url for Cashonize going forward is <a href="https://cashonize.com/">Cashonize.com</a>, please migrate!
  </div>
  <header>
    <img class="cashonize-logo" src="./images/cashonize-logo.png">
    <div>
      <nav class="nav hide">
        <div class="nav-left">
          <div class="tabs">
            <a id="view0" class="view active" onclick="changeView(0)"></a>
            <a id="view1" class="view" onclick="changeView(1)"></a>
            <a id="view2" class="view" onclick="changeView(2)"></a>
            <a id="view4" class="view" onclick="changeView(4)"></a>
            <a id="view3" class="view" onclick="changeView(3)">
              <div><img class="icon settingsIcon" src="/images/settings.svg"></div>
            </a>
          </div>
        </div>
      </nav>
    </div>
  </header>
  <main>
    <div class="container">
      <div id="newWalletView" class="hide">
        <fieldset style="margin-top: 15px;">
            <h4><img class="icon plusIcon" src="/images/plus-square.svg"> Create new wallet</h4>
            <input class="button primary" type="button" value="Create" onclick="createNewWallet()">
            <br><br>
            <hr>
            <br>
            <h4><img class="icon importIcon" src="/images/log-in.svg"> Import existing wallet</h4> 
            <div>Enter mnemonic seed phrase</div>
            <textarea style="resize: none;" id="enterSeedphrase" rows="3" cols="50" placeholder="word1 word2 ..."></textarea>
            <span>Derivation path: </span>
            <select name="derivationPath" id="derivationPath" onchange="selectTokenType(event)">
              <option value="standard">m/44’/145’/0’ (standard)</option>
              <option value="bitcoinfotcom">m/44’/0’/0’ (bitcoin.com wallet)</option>
            </select> <br>
            <input class="button primary" type="button" style="margin-top:15px" value="Import" onclick="importWallet()">
            <br><br>
        </fieldset>
      </div>

      <div id="walletView" class="hide">

        <fieldset style="margin-top: 20px; padding-top: 2rem;">
          <div id="showsUsdBalance">
            <span>USD balance: </span>
            <span id="balanceUsd" class="text-primary"></span>
          </div>
          <div>
            BCH balance: <span id="balance" class="text-primary"></span>
            <span id="balanceUnit" class="text-primary unit"></span>
          </div>
          <div>Wallet token balance: <span id="tokenBalance" class="text-primary"></span></div>
          <div style="word-break: break-all;">BCH address: <span class="depositAddr" id="depositAddr"></span>
            <button type="button" style="background: none; padding: 0;" onclick="copyTextContent('depositAddr')">
              <img class="copyIcon icon" src="/images/copy.svg">
            </button>
          </div>
          <div style="word-break: break-all;">Token address: <span class="depositAddr" id="depositTokenAddr"></span>
            <button type="button" style="background: none; padding: 0;" onclick="copyTextContent('depositTokenAddr')">
              <img class="copyIcon icon" src="/images/copy.svg">
            </button>
          </div>
          <div><img id="placeholderQr" class="placeholderQr" src="./images/qrcode.jpg" /></div>
          <qr-code
            id="qr1"
            contents="loading..."
            class="hide"
            style="
              width: 240px;
              height: 240px;
              margin: 5px auto 0 auto;
              background-color: #fff;
            "
          >
            <img src="/images/bch-icon.png" slot="icon" />
          </qr-code>

          <qr-code
            id="qr2"
            contents="loading.."
            class="hide"
            style="
              width: 240px;
              height: 240px;
              margin: 5px auto 0 auto;
              background-color: #fff;
            "
          >
            <img src="/images/tokenicon.png" slot="icon" />
          </qr-code>

          <div class="is-center"><div id="switchAddress" class="icon" onclick="switchAddressType()">⇄</div></div>
        </fieldset>
        <fieldset style="margin-top: 15px">
          <legend>Send BCH to</legend>
          <p class="inputGroup">
            <span class="addressInput"><input id="sendAddr" placeholder="address"></span>
            <span class="sendAmountGroup">
              <span style="width: 100%;" class="input-icon input-icon-right">
                <input id="sendAmount" type="text" placeholder="amount">
                <i id="sendUnit" style="color: black;">BCH</i>
              </span>
              <button onclick="maxBch(event)" style="color: black;">max</button>
            </span>
          </p>
          <input type="button" class="primaryButton" id="send" value="Send">
        </fieldset>
      </div>

      <div id="tokenView" class="hide tokenView">
        <div id="loadingTokenData">Loading token data...</div>
        <div id="noTokensFound" class="hide">Currently there are no tokens in this wallet...</div>
        <div id="verifiedOnly" class="hide">
          <span>Show verified tokens only </span>
          <input type="checkbox" class="js-switch js-check-change" id="verifiedOnlySwitch">
        </div>
        <div id="noVerifiedTokens" class="hide" style="margin: 20px 0px;">No verified tokens in this wallet...</div>
        <template id="token-template">
          <div class="item">
            <fieldset style="position: relative;">
              <legend>
                <div id="tokenType"></div>
              </legend>
              <div id="verified" class="verified hide">
                <div class="tooltip">
                  <img class="verifiedIcon" src="./images/check-circle.svg">
                  <span class="tooltiptext">Verified</span>
                </div>
              </div>
              <div class="tokenInfo">
                <div id="tokenIcon" class="tokenIcon"></div>
                <div id="tokenIconModal" class="modal">
                  <span class="close">&times;</span>
                  <img class="modal-content" id="imgTokenIcon" style="width: 400px; max-width: 80%;">
                  <div id="caption"></div>
                </div>
                <div class="tokenBaseInfo">
                  <div class="tokenBaseInfo1">
                    <div id="tokenName"></div>
                    <div id="tokenIdBox" style="word-break: break-all;">
                      TokenId: <span id="tokenID" class="tokenID"></span>
                      <button type="button" style="background: none; padding: 0; " onclick="copyTokenID(event)">
                        <img class="copyIcon icon" src="/images/copy.svg">
                      </button>
                    </div>
                    <div id="childNftCommitment" style="word-break: break-all;" class="hide"></div>
                  </div>
                  <div class="tokenAmount" id="tokenAmount"></div>
                  <div class="childNfts" id="childNfts" style=" cursor: pointer;">
                    <span class="nrChildNfts" id="nrChildNfts"></span>
                    <span class="hide" id="showMore" style="margin-left: 10px;">
                      <img id="showIcon" class="icon" style="vertical-align: text-bottom;" src="/images/chevron-square-down.svg">
                    </span>
                  </div>
                  
                </div>
              </div>
              <div class="actionBar">
                <span style="margin-left: 10px;" class="tokenButton" id="sendButton">
                  <img id="sendIcon" class="icon" src="/images/send.svg"> send </span>
                <span class="tokenButton" id="infoButton">
                  <img id="infoIcon" class="icon" src="/images/info.svg"> info 
                </span>
                <span class="tokenButton hide" id="mintButton">
                  <img id="mintIcon" class="icon" src="/images/hammer.svg"> mint NFTs 
                </span>
                <span class="tokenButton hide" style="white-space: nowrap;" id="burnButton">
                  <img id="burnIcon" class="icon" src="/images/fire.svg">
                  <span class="hidemobile">burn NFT</span>
                  <span class="showmobile">burn</span>
                </span>
                <span class="tokenButton hide" style="white-space: nowrap;" id="authButton">
                  <img id="authIcon" class="icon" src="/images/shield.svg">
                  <span class="hidemobile">auth transfer</span>
                  <span class="showmobile">auth</span>
                </span>
                <div id="tokenInfoDisplay" class="hide" style="margin-top: 10px;">
                  <div id="tokenBegin"></div>
                  <div id="tokenDescription"></div>
                  <div id="tokenDecimals"></div>
                  <div id="tokenCommitment"></div>
                  <div id="tokenWebLink"></div>
                  <div id="onchainTokenInfo" style="white-space: pre-line;"></div>
                  <details id="showAttributes" class="hide">
                    <summary>NFT attributes</summary>
                    <div id="nftAttributes" style="white-space: pre-wrap;"></div>
                  </details> 
                </div>
                <div id="tokenSend" class="hide"  style="margin-top: 10px;">
                  Send these tokens to
                  <p class="inputGroup">
                    <span class="addressInput"><input id="tokenAddress" placeholder="token address"></span>
                    <span class="sendAmountGroup">
                      <span style="width: 100%;" class="input-icon input-icon-right">
                        <input id="sendTokenAmount" placeholder="amount">
                        <i id="sendUnit" style="color: black; width: min-content; padding-right: 15px;">tokens</i>
                      </span>
                      <button  id="maxButton" style="color: black;">max</button>
                    </span>
                  </p>
                  <input type="button" id="sendSomeButton" class="primaryButton" value="Send">
                </div>
                <div id="nftSend"  class="hide"  style="margin-top: 10px;">
                  Send this NFT to
                  <p class="grouped">
                    <input id="tokenAddress" placeholder="tokenAddress">
                    <input type="button" class="primaryButton" id="sendNFT" value="Send NFT">
                  </p>
                </div>
                <div id="nftMint"  class="hide"  style="margin-top: 10px;">
                  Mint a number of (unique) NFTs to a specific address
                  <div>
                    <input type="checkbox" checked id="uniqueNFTs" onchange="disableInputfield(event)" style="margin: 0px; vertical-align: text-bottom;">
                    make each NFT unique by numbering each one in the collection
                  </div>
                  <p class="grouped" style="align-items: center; margin-bottom: 5px;">
                    <input id="amountNFTs" type="number" placeholder="amount NFTs">
                    <input id="startingNumberNFTs" type="number" placeholder="starting number" style="margin-right: 0px;">
                    <input id="commitmentNFTs" placeholder="commitment" style="display: none;">
                  </p>
                  <span class="grouped">
                    <input id="destinationAddr" placeholder="destinationAddress"> 
                    <input type="button" id="mintNFTs" value="Mint NFTs">
                  </span>
                </div>
                <div id="nftBurn"  class="hide"  style="margin-top: 10px;">
                  Burn this NFT so no new NFTs of this category can be minted
                  <br>
                  <input type="button" id="burnNFT" value="burn NFT" class="button error">
                </div>
                <div id="authTransfer" class="hide" style="margin-top: 10px;">
                  Transfer the authority to change the token's metadata <br>
                  You can either transfer the Auth to a dedicated wallet or to the <a href="https://cashtokens.studio/" target="_blank">CashTokens Studio</a>.
                  <div id="authInfoFungible">
                    Token supply kept at the Auth UTXO will be marked as reserved supply, not yet in circulation. <br>
                  </div>
                  <details>
                    <summary>Managing your Token's Auth</summary>
                    <p>
                      With the CashTokens Studio managing your token's Auth is easy for regular users.
                      The alternative, using a dedicated wallet, is more complex but gives you more control.
                      For this it's recommended to use Electron Cash on pc to label and freeze the AuthUTXO.
                      Then, to update metadata on-chain<span id="authInfoReserved"> or manage the reserved supply</span>, 
                      use the <a href="https://github.com/mr-zwets/AuthUpdate" target="_blank">AuthUpdate</a> program.<br>
                    </p>
                  </details>
                  <span class="inputGroup grouped">
                    <input id="destinationAddr" placeholder="destinationAddress">
                    <input id="reservedSupply" placeholder="reservedSupply">
                    <input type="button" id="transferAuth" value="Transfer Auth">
                  </span>
                </div>
              </div>
            </fieldset>        
          </div>
        </template>

        <div id="Placeholder"></div>
      </div>

      <div id="createTokensView" class="hide">
        <fieldset class="item">
          <legend>Create new tokens</legend>
          <div style="color: red;" id="warningNoBCH" class="hide">Need BCH in wallet to create tokens</div>

          <div style="margin-bottom: 1em;">
            Planned tokenId:
            <span id="plannedTokenId">loading...</span>
            <button type="button" style="background: none; padding: 0;" onclick="copyTokenID(event,'plannedTokenId')">
              <img class="copyIcon icon" src="/images/copy.svg">
            </button>
          </div>

          <label for="newtokens">Select token-type:</label>
          <select name="newtokens" id="newtokens" onchange="selectTokenType(event)">
            <option autocomplete="off" selected value="-select-">-select-</option>
            <option autocomplete="off" value="fungibles">Fungible Tokens</option>
            <option autocomplete="off" value="mintingNFT">Minting NFT</option>
            <option autocomplete="off" value="immutableNFT">Immutable NFT</option>
          </select>
          <br>
          <div id="infoTokenTypes">
            <b>Fungible Tokens</b> is used to create interchangeable tokens. The total supply of fungible tokens needs to be determined at creation. <br>
            <b>Minting NFT</b> is used to create an NFT collection. The minting NFT has the ability to mint new NFTs with the same tokenId. <br>
            <b>Immutable NFT</b> is used to create a one-off NFT. There is no option to create more NFTs of the same kind. <br><br>
          </div>

          <div id="createTokenType" class="hide">
            <div style="margin-bottom: 1em;">
              Choose the total supply of fungible tokens<br>
              <input id="tokenSupply" placeholder="total supply">
              If you set decimals in the metadata, take the amount of the smallest unit <br>
              <i>(for 100 A-tokens with 2 decimals this means 10,000 units)</i>
            </div>
            <div class="hide" style="margin-bottom: 1em;">
              Add immutable commitment data to add to this NFT (hexadecimals only)
              <input id="inputNftCommitment" placeholder="commitment">
            </div>
            <details  style="margin-bottom: 0.5em;">
              <summary>Optionally link metadata to this token</summary>
              You can add metadata to your Cashtokens using the <a href="https://github.com/bitjson/chip-bcmr" target="_blank">BCMR-standard</a>. <br>
              You create a BCMR JSON file either with the <a href="https://bcmr-generator.netlify.app/" target="_blank">BCMR generator</a> form or
              with a code-editor by using the <a href="https://github.com/bitjson/chip-bcmr/blob/master/bcmr-v2.schema.ts" target="_blank">BCMR-schema</a> 
              and the <a href="https://github.com/bitjson/chip-bcmr/tree/master/examples" target="_blank">official examples</a>. <br>
              You will need to upload the image(s) for your token and this BCMR file to HTTPS or to IPFS.
              The different methods are listed below with more steps for each one. (IPFS recommended) <br><br>       
              <label for="selectUri">Select which method to use: </label>
              <select name="selectUri" id="selectUri" onchange="selectUri(event)">
                <option value="select">- select -</option>
                <option value="github">HTTPS: github gist</option>
                <option value="website">HTTPS: own website</option>
                <option value="IPFS">IPFS</option>
              </select><br>
              <div id="githubInfo" class="hide">
                If you have a GitHub account and know how to use git, you can easily host your BCMR on Github Gist, similar to 
                <a href="https://gist.github.com/mr-zwets/84b0057808af20df392815fb27d4a661" target="_blank">DogeCash</a>. <br>
                You can add an icon image to your gist by following <a href="https://gist.github.com/mroderick/1afdd71aa69f6b29601d335751a1a9be" target="_blank">these steps</a>
                or to put your icon on IPFS, you can use <a href="https://nft.storage/" target="_blank">nft.storage</a> for a single icon or the <a href="https://nft.storage/docs/how-to/nftup/" target="_blank">NFT UP</a> tool for a folders of images. <br>
                Then on Github Gists, press "raw" button and copy the url until <code>/raw</code> in the input field below. <br>
                Your BCMR url together with the hash of its content will be stored on the blockchain.
                <input id="bcmrUrlGithub" placeholder="gist.githubusercontent.com/mr-zwets/323c7786e2acf01e3c04a440d7cf6c2c/raw">
              </div>
              <div id="websiteInfo" class="hide">
                You can also host the BCMR json file on your own website, the recommended location for it is <code>/.well-known/bitcoin-cash-metadata-registry.json</code> 
                like <a href="https://otr.cash/.well-known/bitcoin-cash-metadata-registry.json" target="_blank">the OTR registry</a> does. <br>
                Using this, you only need to enter the base url 'yourtokenwebsite.com' below. <br>
                Your website url together with the hash of the BCMR file will be stored on the blockchain.
                <input id="bcmrUrlWebsite" placeholder="yourtokenwebsite.com">
              </div>
              <div id="ipfsInfo" class="hide">
                You can easily upload (pin) your BCMR on IPFS with <a href="https://nft.storage/" target="_blank">nft.storage</a>. <br>
                Uploading multiple images grouped together on IPFS can be done with the <a href="https://nft.storage/docs/how-to/nftup/" target="_blank">NFT UP</a> tool. <br>
                Enter the IPFS location of your BCMR json file (version 1 CID starting with <code>baf...</code>) below. <br>
                The BCMR location together with the hash of its content will be stored on the blockchain.
                <input id="bcmrIpfs" placeholder="bafkreiaqpmlrtsdf5cvwgh46mpyric2r44ikqzqgtevny74qdmrjc5dkxy">
              </div>
              <br>
            </details>
            <b>Note:</b> Token metadata can still be added/updated later with the token's 
            <a href="https://github.com/bitjson/chip-bcmr#zeroth-descendant-transaction-chains" target="_blank">AuthUTXO</a>. <br>
            This authority to update the metadata (AuthUTXO) should be transferred to a dedicated wallet or to the <a href="https://cashtokens.studio/" target="_blank">CashTokens Studio</a> right after creation.<br><br>
            Process might take a few seconds... 
            <input type="button" class="primaryButton" id="createTokens" value="Create">
          </div>
        </fieldset>
      </div>

      <div id="settingsView" class="hide">
        <fieldset class="item">
          <legend>Settings</legend>
          <span style="margin-top: 15px;">Dark mode </span>
          <input type="checkbox" class="js-switch js-check-change" id="darkmode">
          <div style="margin-top:15px">
            <label for="selectUnit">Select default unit:</label>
            <select name="selectUnit" id="selectUnit" onchange="selectUnit(event)">
              <option value="BCH">BCH</option>
              <option value="satoshis">satoshis</option>
            </select>
          </div>
          <div style="margin-top:15px">
            <label for="selectNetwork">Change network:</label>
            <select name="selectNetwork" id="selectNetwork" onchange="changeNetwork(event)">
              <option value="mainnet">mainnet</option>
              <option value="chipnet">chipnet</option>
            </select>
          </div>
          <div style="margin-top:15px">Make backup of seed phrase (mnemonic)</div>
          <input class="button primary" type="button" style="padding: 1rem 1.5rem; display: block;" value="Show seed phrase" onclick="toggleSeedphrase(event)">
          <div id="seedphrase" class="hide"></div><br>
          <span style="margin-top:15px">Derivation path of this wallet is</span> <span id="walletDerivationPath"></span>
          <div style="margin-top:15px">Remove wallet data from browser</div>
          <input type="button" id="burnNFT" value="Delete wallet" class="button error" style="display: block;" onclick="confirmDeleteWallet(event)">
        </fieldset>
      </div>

      <div id="walletConnectView" class="hide">
        <fieldset style="display: block; margin-top: 15px;">
          <legend>Connect</legend>
          <p class="inputGroup">
            <span style="width: 100%;" class="addressInput"><input id="wcUri" placeholder="Wallet Connect URI"></span>
          </p>
          <div style="display: flex; flex-wrap: wrap; justify-content: center; gap: 2rem; margin-bottom: 1rem;">
            <input type="button" class="primaryButton" id="connect-button" value="Connect New dApp">
            <input type="button" class="primaryButton" id="scan-button" value="Scan QR Code">
          </div>
        </fieldset>

        <!-- WalletConnect -->
        <fieldset id="sessions" style="display: block; margin-top: 15px">
          <legend>WalletConnect Sessions</legend>
          <div id="wc-sessions" style="display: flex; flex-direction: column;">
          </div>
        </fieldset>

        <!-- CashConnect (Vue Container) -->
        <div id="cashconnect-sessions-vue">
          <!-- Sessions -->
          <fieldset style="display: block; margin-top: 15px">
            <legend>CashConnect Sessions (Pre-Alpha)</legend>
            <div class="cc-session-items-container">
              <!-- Iterate over active sessions -->
              <template v-for="(session, topic) of sessions" :key="topic">
                <div class="cc-session-item">
                  <div class="cc-session-item-app-icon"><img :src="session.peer.metadata.icons[0]"></div>
                  <div class="cc-session-item-details-container">
                    <div>{{ session.peer.metadata.name }}</div>
                    <div><a href="session.peer.metadata.url" target="_blank">{{ session.peer.metadata.url }}</a></div>
                    <div>{{ session.peer.metadata.description }}</div>
                  </div>
                  <div class="cc-session-item-action-container">
                    <div class="cc-session-item-action-icon" @click="disconnectSession(topic)"><img class="trashIcon icon"></div>
                  </div>
                </div>
              </template>
            </div>
          </fieldset>
        </div>
      </div>

      <br>
      <footer class="footer hide" id="githubLink">
        <a href="https://github.com/cashonize/wallet" target="_blank" >
            <img class="githublogo" src="./images/github.png" alt="Github logo">
        </a>
        <div style="margin-left: 10px;height: 60px;">
          <a href="https://github.com/cashonize/wallet" target="_blank">
          <div>
            inspect source code
          </div>
          </a>
          <div>
            made with mainnet-js
          </div>
        </div>
        
      </footer>
    </div>

    <div id="wc-session-approval-modal" style="top: 0; display: none; position: fixed; align-items: center; justify-content: center; backdrop-filter: blur(24px); -webkit-backdrop-filter: blur(24px); z-index: 10; width: 100%; height: 100%; padding: 5rem;">
      <fieldset id="wc-session-approval-modal-inner" class="modalClass icon" style="padding: 3rem; width: 100%; max-width: 500px; overflow-y: scroll; height: 250px; background-color: white;">
        <legend style="font-size: larger;">Approve Session?</legend>
        <div id="wc-session-approval" style="display: flex; flex-direction: column; gap: 1rem;">
        </div>
        <div style="margin-top: 1rem; display: flex; flex-wrap: wrap; gap: 1rem;">
          <input id="session-approve-button" class="button primary" type="button" value="Approve">
          <input id="session-reject-button" style="margin-left: 0;" class="button" type="button" value="Reject">
        </div>
      </fieldset>
    </div>

    <div id="wc-session-history-modal" style="top: 0; display: none; position: fixed; align-items: center; justify-content: center; backdrop-filter: blur(24px); -webkit-backdrop-filter: blur(24px); z-index: 10; width: 100%; height: 100%;">
      <fieldset id="wc-session-history-modal-inner" class="modalClass icon" style="width: 100%; max-width: 500px; overflow-y: scroll; max-height: 90vh; background-color: white;">
        <legend style="font-size: larger;">Session</legend>
        <div style="display: flex; flex-direction: column; gap: 3px">
          <div style="display: flex; align-items: center;">
            <input type="checkbox" id="session-auto">
            <label for="session-auto">Auto-approve requests</label>
          </div>
          <div style="display: flex; align-items: center;">
            <input id="session-auto-requests" type="number" min="1" max="999" placeholder="For N requests" oninput="validity.valid||(value='');">
            <span id="session-auto-requests-left" style="width: 77px; text-align: end;">&infin; left</span>
          </div>
          <div style="display: flex; align-items: center;">
            <select id="session-auto-minutes">
              <option disabled selected value="">For N minutes</option>
              <option value="10">10 minutes</option>
              <option value="30">30 minutes</option>
              <option value="60">60 minutes</option>
            </select>
            <span id="session-auto-minutes-left" style="width: 77px; text-align: end;">&infin;m left</span>
          </div>
        </div>
        <fieldset id="history" style="display: block; margin-top: 12px">
          <legend>Request History</legend>
          <div id="wc-history" style="display: flex; flex-direction: column; gap: 1rem;">
          </div>
        </fieldset>
      </fieldset>
    </div>

    <div id="wc-session-request-modal-container" style="top: 0; display: none; flex-wrap: wrap-reverse; overflow-y: scroll; gap: 5rem; position: fixed; align-items: center; justify-content: center; backdrop-filter: blur(24px); -webkit-backdrop-filter: blur(24px); z-index: 10; width: 100%; height: 100%;">
    </div>

    <div id="wc-session-scan-modal" style="top: 0; display: none; position: fixed; align-items: center; justify-content: center; backdrop-filter: blur(24px); -webkit-backdrop-filter: blur(24px); z-index: 10; width: 100%; height: 100%; padding: 5rem;">
      <fieldset id="wc-session-scan-modal-inner" class="modalClass icon" style="padding: 3rem; width: 350px; overflow-y: scroll; background-color: white;">
        <legend style="font-size: larger;">Scan QR Code</legend>
        <div id="reader"></div>
      </fieldset>
    </div>

    <!-- CashConnect Dialogs -->
    <div id="cashconnect-dialogs-vue">
      <!-- Session Approval Dialog -->
      <div v-if="isSessionApprovalVisible" class="cc-modal">
        <!-- Iterate over pending session approval dialogs -->
        <template v-for="(request, i) of sessionRequests" :key="request.session.topic">
          <fieldset class="cc-modal-fieldset">
            <legend style="font-size: larger;">Approve Session?</legend>
            <div  style="display: flex; flex-direction: column; gap: 1rem;">
              <!-- App Info -->
              <div style="display: flex; align-items: center; flex-direction: row; gap: 10px; padding: 7px;">
                <!-- App Icon -->
                <div style="display: flex; align-items: center; height: 64px; width: 64px;">
                  <img :src="request.session.params.proposer.metadata.icons[0]">
                </div>

                <!-- Metadata -->
                <div style="display: flex; flex-direction: column; width: 100%;">
                  <div>{{ request.session.params.proposer.metadata.name }}</div>
                  <div><a :href="request.session.params.proposer.metadata.url" target="_blank">{{ request.session.params.proposer.metadata.url }}</a></div>
                  <div>{{ request.session.params.proposer.metadata.description }}</div>
                </div>
              </div>

              <!-- Namespaces -->
              <div class="cc-modal-details">
                <!-- Template -->
                <div class="cc-modal-section">
                  <div class="cc-modal-heading">Template</div>
                  <a @click="viewTemplate(request.session.params.requiredNamespaces?.bch?.template)">{{ request.session.params.requiredNamespaces?.bch?.template.name }}</a> (Untrusted)
                </div>

                <!-- Methods -->
                <div class="cc-modal-section">
                  <div class="cc-modal-heading">Methods/Events</div>
                  <ul>
                    <li v-for="method of request.session.params.requiredNamespaces?.bch?.methods">{{ method }}</li>
                    <li v-for="event of request.session.params.requiredNamespaces?.bch?.events">{{ event }}</li>
                  </ul>
                </div>

                <!-- Allowed Tokens -->
                <div class="cc-modal-section">
                  <div class="cc-modal-heading">Allowed Tokens</div>
                  <ul>
                    <li v-for="allowedToken of request.session.params.requiredNamespaces?.bch?.allowedTokens">{{ allowedToken }}</li>
                  </ul>
                </div>
              </div>
            </div>
            <!-- Approve/Reject Buttons -->
            <div class="cc-modal-bottom-buttons">
              <input class="button primary" type="button" value="Approve" @click="request.accept()">
              <input class="button" type="button" value="Reject" @click="request.reject()">
            </div>
          </fieldset>
        </template>
      </div>
      <!-- End Session Approval Dialog -->

      <!-- Request Approval Dialog -->
      <div v-if="isRequestApprovalVisible" class="cc-modal">
        <!-- Iterate over our session requests and display them. -->
        <template v-for="({ method, session, params, response, modalId, accept, reject}, i) of rpcRequests" :key="i">
          <!-- bch_signTransaction_V0 -->
          <template v-if="method === 'bch_signTransaction_V0'">
            <fieldset class="cc-modal-fieldset">
              <legend class="cc-modal-fieldset-legend">Sign Transaction</legend>

              <!-- Origin -->
              <div style="font-size: large; margin-top: 2rem;">Origin:</div>
              <div style="display: flex; align-items: center; flex-direction: row; gap: 10px; padding: 7px;">
                <div style="display: flex; align-items: center; height: 64px; width: 64px;"><img :src="session.peer.metadata.icons[0]"></div>
                <div style="display: flex; flex-direction: column; width: 100%;">
                  <div>{{ session.peer.metadata.name }}</div>
                  <div style="overflow-wrap: anywhere;"><a :href="session.peer.metadata.url" target="_blank">{{ session.peer.metadata.url }}</a></div>
                  <div style="overflow-x: hidden; text-overflow: ellipsis; font-size: smaller;">{{ formatSessionSigner(session) }}</div>
                </div>
              </div>

              <hr style="margin-top:3rem" />

              <div v-for="(tx, i) of params" class="cc-modal-details">
                <!-- User Prompt -->
                <div v-if="tx.userPrompt" style="display: flex; justify-content: center; font-size: larger;">{{ tx.userPrompt }}</div>

                <!-- Inputs -->
                <div class="cc-modal-heading">Inputs</div>
                <table class="cc-data-table">
                  <tbody v-for="(input, index) of response[i].transaction.inputs">
                    <tr>
                      <td>{{ index }}</td>
                      <td>{{ formatBin(input.outpointTransactionHash) }}:{{ input.outpointIndex }}</td>
                      <td class="satoshis">
                        {{ formatSats(response[i].sourceOutputs[index].valueSatoshis) }}
                      </td>
                    </tr>
                    <!-- If there is data available for this input -->
                    <tr v-if="tx.transaction.inputs?.[index]?.data">
                      <td colspan="3">
                        <table class="tx-data-table">
                          <tbody>
                            <tr>
                              <td colspan="2">
                                <strong>{{ formatScriptName(tx.transaction.inputs[index].script, session.requiredNamespaces.bch.template) }}</strong>
                              </td>
                            </tr>
                            <tr v-for="(value, id) of tx.transaction.inputs?.[index]?.data">
                              <td>{{ formatDataName(id, session.requiredNamespaces.bch.template) }}</td>
                              <td>{{ formatDataValue(value, id, session.requiredNamespaces.bch.template) }}</td>
                            </tr>
                          </tbody>
                        </table>
                      </td>
                    </tr>
                  </tbody>
                </table>

                <!-- Outputs -->
                <div class="cc-modal-heading">Outputs</div>
                <table class="cc-data-table">
                  <tbody v-for="(output, index) of response[i].transaction.outputs">
                    <tr>
                      <td>{{ index }}</td>
                      <td>{{ formatLockscript(output.lockingBytecode) }}</td>
                      <td class="satoshis">{{ formatSats(output.valueSatoshis) }}</td>
                    </tr>
                    <!-- If there is a token available on this output -->
                    <tr v-if="output.token">
                      <td colspan="3">
                        <table class="tx-data-table">
                          <tbody>
                            <tr>
                              <td>
                                Token: {{ formatBin(output.token.category) }}
                              </td>
                              <td>
                                Amount: {{ Number(output.token.amount) }}
                              </td>
                            </tr>
                            <tr v-if="output.token?.nft">
                              <td>Commitment: {{ formatBin(output.token.nft.commitment) }}</td>
                              <td>Capability: {{ output.token.nft.capability }}</td>
                            </tr>
                          </tbody>
                        </table>
                      </td>
                    </tr>
                    <!-- If there is data available for this output -->
                    <tr v-if="tx.transaction.outputs?.[index]?.data">
                      <td colspan="3">
                        <table class="tx-data-table">
                          <tbody>
                            <tr>
                              <td colspan="2">
                                <strong>{{ formatScriptName(tx.transaction.outputs[index].script, session.requiredNamespaces.bch.template) }}</strong>
                              </td>
                            </tr>
                            <tr v-for="(value, id) of tx.transaction.outputs?.[index]?.data">
                              <td>{{ formatDataName(id, session.requiredNamespaces.bch.template) }}</td>
                              <td>{{ formatDataValue(value, id, session.requiredNamespaces.bch.template) }}</td>
                            </tr>
                          </tbody>
                        </table>
                      </td>
                    </tr>
                  </tbody>
                </table>

                <hr style="margin-top: 3rem;" />
              </div>

              <!-- Bottom Buttons -->
              <div class="cc-modal-bottom-buttons">
                <input class="button primary" type="button" value="Sign" @click="accept(modalId)">
                <input class="button" type="button" value="Cancel" @click="reject(modalId)">
              </div>
            </fieldset>
          </template>
          <!-- End bch_signTransaction_V0 -->

          <!-- Unhandled Method -->
          <template v-else>
            <fieldset class="cc-modal-fieldset">
              <legend class="cc-modal-fieldset-legend">{{ method }}</legend>

              <div>Params:</div>
              <pre class="cc-pre">{{ params }}</pre>
              <div>Response:</div>
              <pre class="cc-pre">{{ response }}</pre>

              <!-- Bottom Buttons -->
              <div class="cc-modal-bottom-buttons">
                <input class="button primary" type="button" value="Sign" @click="accept(modalId)">
                <input class="button" type="button" value="Cancel" @click="reject(modalId)">
              </div>
            </fieldset>
          </template>
          <!-- End Unhandled Method -->
        </template>
      </div>
      <!-- End Request Approval Dialog -->

      <!-- Error Dialog -->
      <template v-for="({ error, modalId, accept, reject}, i) of errors" :key="i">
        <div v-if="isErrorsVisible" class="cc-modal">
          <fieldset class="cc-modal-fieldset" style="width:1024px">
            <legend class="cc-modal-fieldset-legend">Error</legend>

            <div v-if="error.message">{{ error.message }}</div>

            <template v-if="error.stackTrace">
              <div>Stack Trace:</div>
              <pre class="cc-pre">{{ error.stackTrace }}</pre>
            </template>

            <!-- Bottom Buttons -->
            <div class="cc-modal-bottom-buttons">
              <input class="button primary" type="button" value="Close" @click="accept(modalId)">
            </div>
          </fieldset>
        </div>
      </template>
      <!-- End Error Dialog -->
    </div>
    <!-- End CashConnect Dialogs -->
  </main>

  <script type="module" src="./script.js"></script>
  <script type="module" src="./cash-connect.js"></script>
  <script type="module" src="./wallet-connect.js"></script>
  <script type="module" src="./queryChainGraph.js"></script>
  <script>
    document.getElementById('qr1').addEventListener('codeRendered', () => {
      document.getElementById('qr1').animateQRCode('MaterializeIn');
    });
  </script>
</body>

</html>
